#!/bin/sh
if [ $# != 4 ]
then
    echo "Ne me lancer pas ;-)"
    echo "Mon maitre est fricorder ..."
    exit
fi
STREAM=$1
LENGTH=$2
MODE=$3
OUTFILE=$4

pidfile=`pwd`/tmp/`basename $OUTFILE`.pid

#--------------------------------------
function Exit() {
#--------------------------------------
 if [ -f $pidfile ]
 then
         for i in `cat $pidfile`
         do
               kill -9 $i
         done
         rm -rf $pidfile
 fi
 sync
 exit 0
}

#--------------------------------------
function savePid() {
#--------------------------------------
 echo $1>>$pidfile
}


# trap le sigexit
trap Exit 0

# lance le process principale
case $MODE in
  ogm)
    #vlc $STREAM --filter deinterlace:bob --sout "#transcode{vcodec=mp1v,vb=512,scale=0.75,acodec=mpga,ab=96,channels=2}:std{access=file,mux=ps,url=$OUTFILE}" -I dummy &
    vlc $STREAM --filter deinterlace:bob --sout "#transcode{vcodec=mp4v,vb=512,scale=0.75,acodec=vorb,ab=64,channels=2}:std{access=file,mux=ogg,url=$OUTFILE.ogm}" -I dummy &

    pid_main=$!
    ;;
  *)
    vlc $STREAM --filter deinterlace:bob --sout "#std{access=file,mux=ts,url=$OUTFILE.mpg}" -I dummy &
    pid_main=$!
esac
savePid $pid_main

(
 (
   # lance le process de notification
   zenity --display=:0.0 --progress --pulsate --title "FriCorder: Enregistrement de" --text `basename $OUTFILE` &
   pid_notif=$!
   savePid $pid_notif
   wait $pid_notif
 ) &
 wait $!
 Exit
) &

(
 # lance le process de timing d'enregistrement
 sleep $LENGTH &
 pid_sleep=$!
 savePid $pid_sleep
 wait $pid_sleep
 Exit
) &

# attends la fin de l'enregistrement
wait $pid_main
Exit
